Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.analysis.miscellaneous
Class PrefixAwareTokenFilter

    java.lang.Object
      org.apache.lucene.analysis.TokenStream
          org.apache.lucene.analysis.miscellaneous.PrefixAwareTokenFilter

    public class PrefixAwareTokenFilter

extends TokenStream

Joins two token streams and leaves the last token of the first stream available to be used when updating the token values in the second stream based on that token. The default implementation adds last prefix token end offset to the suffix token start and end offsets.

Constructor Summary
`PrefixAwareTokenFilter(TokenStream prefix, TokenStream suffix)`

Method Summary
`void` | `close()` Releases resources associated with this stream.
`TokenStream` | `getPrefix()`
`TokenStream` | `getSuffix()`
`Token` | `next(Token reusableToken)` Returns the next token in the stream, or null at EOS.
`void` | `reset()` Resets this stream to the beginning.
`void` | `setPrefix(TokenStream prefix)`
`void` | `setSuffix(TokenStream suffix)`
`Token` | `updateSuffixToken(Token suffixToken, Token lastPrefixToken)` The default implementation adds last prefix token end offset to the suffix token start and end offsets.

Methods inherited from class org.apache.lucene.analysis.TokenStream
`next`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PrefixAwareTokenFilter

    public PrefixAwareTokenFilter(TokenStream prefix,
                                  TokenStream suffix)

Method Detail

### next

    public Token next(Token reusableToken)
               throws IOException

  Description copied from class: `TokenStream`
  Returns the next token in the stream, or null at EOS. When possible, the input Token should be used as the returned Token (this gives fastest tokenization performance), but this is not required and a new Token may be returned. Callers may re-use a single Token instance for successive calls to this method.

  This implicitly defines a "contract" between consumers (callers of this method) and producers (implementations of this method that are the source for tokens):

  - A consumer must fully consume the previously returned Token before calling this method again.
  - A producer must call `Token.clear()` before setting the fields in it & returning it
  Also, the producer must make no assumptions about a Token after it has been returned: the caller may arbitrarily change it. If the producer needs to hold onto the token for subsequent calls, it must clone() it before storing it. Note that a `TokenFilter` is considered a consumer.

  Overrides:
    `next` in class `TokenStream`
  Parameters:
    `reusableToken` - a Token that may or may not be used to return; this parameter should never be null (the callee is not required to check for null before using it, but it is a good idea to assert that it is not null.)
  Returns:
    next token in the stream or null if end-of-stream was hit
  Throws:
    `IOException`

### updateSuffixToken

    public Token updateSuffixToken(Token suffixToken,
                                   Token lastPrefixToken)

  The default implementation adds last prefix token end offset to the suffix token start and end offsets.

  Parameters:
    `suffixToken` - a token from the suffix stream
    `lastPrefixToken` - the last token from the prefix stream
  Returns:
    consumer token

### close

    public void close()
               throws IOException

  Description copied from class: `TokenStream`
  Releases resources associated with this stream.

  Overrides:
    `close` in class `TokenStream`
  Throws:
    `IOException`

### reset

    public void reset()
               throws IOException

  Description copied from class: `TokenStream`
  Resets this stream to the beginning. This is an optional operation, so subclasses may or may not implement this method. Reset() is not needed for the standard indexing process. However, if the Tokens of a TokenStream are intended to be consumed more than once, it is necessary to implement reset(). Note that if your TokenStream caches tokens and feeds them back again after a reset, it is imperative that you clone the tokens when you store them away (on the first pass) as well as when you return them (on future passes after reset()).

  Overrides:
    `reset` in class `TokenStream`
  Throws:
    `IOException`

### getPrefix

    public TokenStream getPrefix()

### setPrefix

    public void setPrefix(TokenStream prefix)

### getSuffix

    public TokenStream getSuffix()

### setSuffix

    public void setSuffix(TokenStream suffix)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.